#include <hmg.ch>

PROCEDURE empe()
  
  Public New := .F.

  DEFINE WINDOW Win_1		;
    AT 0,0			;
    WIDTH 800			;
	HEIGHT 600		;
    TITLE 'Employee  '	;
    MODAL

    DEFINE STATUSBAR FONT 'Arial' SIZE 12

    STATUSITEM 'SoleX Power Ready !  ' 
    KEYBOARD
    DATE
    CLOCK

    END STATUSBAR

    DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 59,35 IMAGESIZE 30,30  FLAT BORDER

    BUTTON PRIMERO 		;
      CAPTION 'First';
      PICTURE 'edit_top.bmp';	
      ACTION ( dBGoTop() , Win_1.Browse_1.Value := RecNo() )

    BUTTON ANTERIOR 	;
      CAPTION 'Prev'	;
      PICTURE 'edit_del.bmp'	;
      ACTION ( dBSkip ( -1 ) , Win_1.Browse_1.Value := RecNo() )

    BUTTON SIGUIENTE	;
      CAPTION 'Next' 	;
      PICTURE 'edit_add.bmp'	;
      ACTION ( dBSkip (1) , if ( Eof() , DbGoBottom() , Nil ) , Win_1.Browse_1.Value := RecNo() )

    BUTTON ULTIMO 		;
      CAPTION 'Last' 	;
      PICTURE 'edit_end.bmp'	;
      ACTION ( dBGoBottom () , Win_1.Browse_1.Value := RecNo() )  SEPARATOR

    BUTTON BUSCAR		;
      CAPTION 'Find' ;
      PICTURE 'edit_find.bmp' ;
      ACTION Find()

    BUTTON Nuevo 		;
      CAPTION 'New' 	;
      PICTURE 'edit_new.bmp'	;
      ACTION ( New := .T. , New() )

    BUTTON EDITAR 		;
      CAPTION 'Edit' 	;
      PICTURE 'edit_edit.bmp' ;	
      ACTION If ( BloquearRegistro() , ActivarEdicion() , Nil )

    BUTTON ELIMINAR 	;
      CAPTION 'Delete'	;
      PICTURE 'Edit_delete.bmp'	;
      ACTION ( BloquearRegistro() , Eliminar() , Nil )

    BUTTON IMPRIMIR 	;
      CAPTION 'Print'	;
      PICTURE 'edit_print.bmp' ;
      ACTION Imprimir()

    BUTTON CERRAR 	;
      CAPTION 'Exit'	;
      PICTURE 'edit_close.bmp' ;
      ACTION Win_1.release

    END TOOLBAR

    Spot_cli()

    @ 90,10 Browse Browse_1 ;
      OF Win_1 ;
      WIDTH 400 ;
      HEIGHT 460 ;	
      FONT 'Arial' ;
      SIZE 11 ;
      HEADERS { 'No' , 'Name' }	;
      WIDTHS { 75, 350 } ;
      WORKAREA emp ;
      FIELDS { 'empno' , 'ename' } ;
      ON CHANGE Actualizar() ;
      ON HEADCLICK { {||head1()} , {||head2()} } ;
      ON DBLCLICK ( ActivarEdicion() , If ( ! BloquearRegistro() , DesactivarEdicion() , Nil ) )

    @ 580,50 BUTTON SAVE ;
      CAPTION 'Save' ;
      PICTURE 'ok.bmp'	 ;
      ACTION AceptarEdicion() ;
      RIGHT ;
      WIDTH 100 ;
      HEIGHT 50

    @ 580,150 BUTTON CANCEL ;
      CAPTION 'Cancel' ;
      PICTURE 'cancel.bmp' ;	
      ACTION CancelarEdicion() ;
      RIGHT ;
      WIDTH 100 ;
      HEIGHT 50

  END WINDOW

  DesactivarEdicion()

  Win_1.Browse_1.SetFocus
  Win_1.Browse_1.Value :=emp->(RecNo())

  ACTIVATE WINDOW Win_1

RETURN
*------------------------------------------------------------*
PROCEDURE DesactivarEdicion
*------------------------------------------------------------*
  Win_1.Browse_1.Enabled	:= .T.

  Win_1.Control_1.Enabled	:= .F.
  Win_1.Control_2.Enabled	:= .F.
  Win_1.Control_3.Enabled	:= .F.
  Win_1.Control_4.Enabled	:= .F.
  Win_1.Control_5.Enabled	:= .F.
  Win_1.Control_6.Enabled	:= .F.
  Win_1.Control_7.Enabled	:= .F.
  Win_1.Control_8.Enabled	:= .F.
  
  Win_1.Save.Enabled		:= .F.
  Win_1.Cancel.Enabled		:= .F.
  Win_1.ToolBar_1.Enabled	:= .T.
  Win_1.Browse_1.SetFocus

RETURN
*------------------------------------------------------------*
PROCEDURE ActivarEdicion
*------------------------------------------------------------*
  Win_1.Browse_1.Enabled		:= .F.

  Win_1.Control_1.Enabled		:= .F. 	
  Win_1.Control_2.Enabled		:= .T. 	
  Win_1.Control_3.Enabled		:= .T. 	
  Win_1.Control_4.Enabled		:= .T.
  Win_1.Control_5.Enabled		:= .T.
  Win_1.Control_6.Enabled		:= .T. 	
  Win_1.Control_7.Enabled		:= .T.
  Win_1.Control_8.Enabled		:= .T. 		
  
  win_1.Save.Enabled			:= .T.
  Win_1.Cancel.Enabled		        := .T.
  Win_1.ToolBar_1.Enabled		:= .F.
  Win_1.Control_2.SetFocus

RETURN
*------------------------------------------------------------*
Function BloquearRegistro()
*------------------------------------------------------------*
  Local RetVal

  emp->( dbGoTo ( Win_1.Browse_1.Value ) )	

  If emp->(RLock())
    RetVal := .t.
  Else
    MsgExclamation ("Registration outstanding editing by another user. If you should onlineflashfreegames.net  try again later")
    RetVal := .f.
  EndIf

Return RetVal
*------------------------------------------------------------*
PROCEDURE Actualizar()
*------------------------------------------------------------*
  emp->( dbGoTo ( Win_1.Browse_1.Value ) )

  //Win_1.Control_2.Value	:= Tipos->(RecNo())

  Win_1.Control_1.Value		:= emp->empno
  Win_1.Control_2.Value		:= emp->ename
  Win_1.Control_3.Value		:= emp->job
  Win_1.Control_4.Value		:= emp->mgr
  Win_1.Control_5.Value		:= emp->hiredate
  Win_1.Control_6.Value		:= emp->sal
  Win_1.Control_7.Value		:= emp->comm
  Win_1.Control_8.Value		:= emp->deptno
  
RETURN
*------------------------------------------------------------*
PROCEDURE CancelarEdicion()
*------------------------------------------------------------*
  DesactivarEdicion()
  Actualizar()
  UNLOCK
  New := .F.

RETURN
*------------------------------------------------------------*
PROCEDURE AceptarEdicion()
*------------------------------------------------------------*
  local NewRecNo

  DesactivarEdicion()

  If New == .T.
    emp->(DbAppend())
    New := .F.
  else
    emp->(dbGoTo ( Win_1.Browse_1.Value ) )
  EndIf

  NewRecNo := emp->( RecNo() )

  emp->empno	:= Win_1.Control_1.Value
  emp->ename	:= Win_1.Control_2.Value
  emp->job	:= Win_1.Control_3.Value
  emp->mgr	:= Win_1.Control_4.Value
  emp->hiredate	:= Win_1.Control_5.Value
  emp->sal	:= Win_1.Control_6.Value
  emp->comm 	:= Win_1.Control_7.Value
  emp->deptno	:= Win_1.Control_8.Value

  Win_1.Browse_1.Refresh
  If New == .T.
    Win_1.Browse_1.Value := NewRecNo
  EndIf
  
  UNLOCK
  dbcommitall()

RETURN
*------------------------------------------------------------*
PROCEDURE New()
*------------------------------------------------------------*
  set order to 1
*  set filter to emp->cod_cli#'41118000'
  dBGoBottom ()
  Win_1.Control_1.Value		:= alltrim(str((val(emp->empno)+1)))
  Win_1.Control_2.Value		:= 'Enter NAME'
  Win_1.Control_3.Value		:= 'Enter JOB'
  Win_1.Control_4.Value 	:= 0
  Win_1.Control_5.Value 	:= date()
  Win_1.Control_6.Value 	:= 0
  Win_1.Control_7.Value		:= 0
  Win_1.Control_8.Value		:= 0

  ActivarEdicion()
RETURN
*------------------------------------------------------------*
Procedure Eliminar()
*------------------------------------------------------------*
  If MsgYesNo ( 'Are you Sure you want to delete the Customer?')
    If emp->(FLock())
       Delete
       Win_1.Browse_1.Delete
       Win_1.Browse_1.EnableUpdate()
       Win_1.Browse_1.Refresh
      Unlock
    endif  
  EndIf
Return
*------------------------------------------------------------*
Procedure Find()
*------------------------------------------------------------*
  Local Find

  Find := Upper (AllTrim(InputBox( 'Code/Raison Client:' , 'Chercher un Client' )))

  If .Not. Empty(Find)
    set softseek on
    If emp->(DbSeek(Find))

      Win_1.Browse_1.Value := emp->(RecNo())
    Else
      MsgExclamation('Code Client Enexistant')
    EndIf
  EndIf

Return
*------------------------------------------------------------*
Procedure Imprimir()
*------------------------------------------------------------*
  Local RecContactos , RecTipos

  RecClient := emp->(RecNo())
  Go Top
  DO REPORT								;
    TITLE 'Client'						;
    HEADERS  {'','','','',''} , {'No','Name','Job','Sal','Deptno'};
    FIELDS   {'emp->empno','emp->ename','emp->job','emp->sal','emp->deptno'};
    WIDTHS   {10,15,20,7,15} 						;
    TOTALS   {.F.,.F.,.F.,.F.,.F.}					;
    WORKAREA emp							;
    LPP 50								;
    CPL 80								;
    LMARGIN 5							;
    PREVIEW							
  emp->(DbGoTo(RecClient))

Return
*------------------------------------------------------------*
PROCEDURE SPOT_CLI()
*------------------------------------------------------------*
  @ 80,410 FRAME FRAME_1 WIDTH 520 HEIGHT 590			

  @ 90,420  LABEL LABEL_1 VALUE "No "     //WIDTH 80
  @ 90,597  LABEL LABEL_2 VALUE "Name "     //WIDTH 100
  @ 120,597 LABEL LABEL_3 VALUE "Job "     //WIDTH 80
  @ 120,420 LABEL LABEL_4 VALUE "Manager "     //WIDTH 100
  @ 150,420 LABEL LABEL_5 VALUE "Hiredate "
  @ 150,597 LABEL LABEL_6 VALUE "Salaty "     //WIDTH 100
  @ 180,420 LABEL LABEL_7 VALUE "Commision "     //WIDTH 120
  @ 210,420 LABEL LABEL_8 VALUE "Department "  //WIDTH 150

RETURN
*------------------------------------------------------------*
PROCEDURE head1()
  select emp
  SET ORDER TO 1
  Win_1.Browse_1.Value :=RECNO()
  DBGOTOP()
  Win_1.Browse_1.Refresh
RETURN
*------------------------------------------------------------*
PROCEDURE head2()
  select emp
  SET ORDER TO 2
  Win_1.Browse_1.Value :=RECNO()
  DBGOTOP()
  Win_1.Browse_1.Refresh
  Actualizar()
RETURN
*------------------------------------------------------------*